config/routes.rb
Rails.application.routes.draw do
  root 'pages#home'

  use_doorkeeper
  
  devise_for :users
  resources :books

  draw :api
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/book.rb
class Book < ApplicationRecord
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  validates :email, format: URI::MailTo::EMAIL_REGEXP
  enum role: %i[user admin]

  def self.authenticate(email, password)
    user = User.find_for_authentication(email: email)
    user&.valid_password?(password) ? user : nil
  end

end

app/controllers/api/v1/android/books_controller.rb
class Api::V1::Android::BooksController < ApiController
  include ApplicationHelper
  before_action :set_book, only: %i[ show ]
  before_action :is_admin?

  # GET /books or /books.json
  def index
    @books = Book.all
    render json: @books
  end

  # GET /books/1 or /books/1.json
  def show
    render json: @book
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_book
    @book = Book.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def book_params
    params.require(:book)
  end
end

app/controllers/api/v1/books_controller.rb
class Api::V1::BooksController < ApiController
  include ApplicationHelper
  before_action :set_book, only: %i[ show edit update destroy ]

  # GET /books or /books.json
  def index
    @books = Book.all
    render json: @books
  end

  # GET /books/1 or /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books or /books.json
  def create
    @book = Book.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to book_url(@book), notice: "Book was successfully created." }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1 or /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to book_url(@book), notice: "Book was successfully updated." }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1 or /books/1.json
  def destroy
    @book.destroy

    respond_to do |format|
      format.html { redirect_to books_url, notice: "Book was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_book
    @book = Book.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def book_params
    params.require(:book).permit(:title, :body)
  end
end

app/controllers/api/v1/users/registrations_controller.rb
module Api
  module V1
    module Users
      class RegistrationsController < ApiController
        skip_before_action :doorkeeper_authorize!, only: %i[create]

        include DoorkeeperRegisterable

        def create
          client_app = Doorkeeper::Application.find_by(uid: user_params[:client_id])
          unless client_app
            return render json: { error: I18n.t("doorkeeper.errors.messages.invalid_client") },
                          status: :unauthorized
          end

          allowed_params = user_params.except(:client_id)
          user = User.new(allowed_params)

          if user.save
            render json: render_user(user, client_app), status: :ok
          else
            render json: { errors: user.errors }, status: :unprocessable_entity
          end
        end

        private

        def user_params
          params.permit(:email, :password, :client_id)
        end
      end
    end
  end
end

app/controllers/api_controller.rb
class ApiController < ApplicationController
  before_action :doorkeeper_authorize!

  skip_before_action :verify_authenticity_token

  respond_to :json

  def current_user
    return unless doorkeeper_token

    @current_user ||= User.find_by(id: doorkeeper_token[:resource_owner_id])
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  before_action :set_book, only: %i[ show edit update destroy ]
  before_action :authenticate_user!

  # GET /books or /books.json
  def index
    @books = Book.all
  end

  # GET /books/1 or /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books or /books.json
  def create
    @book = Book.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to book_url(@book), notice: "Book was successfully created." }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1 or /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to book_url(@book), notice: "Book was successfully updated." }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1 or /books/1.json
  def destroy
    @book.destroy

    respond_to do |format|
      format.html { redirect_to books_url, notice: "Book was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_book
      @book = Book.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def book_params
      params.require(:book).permit(:title, :body)
    end
end

app/controllers/concerns/doorkeeper_registerable.rb
module DoorkeeperRegisterable
  extend ActiveSupport::Concern

  def generate_refresh_token
    loop do
      token = SecureRandom.hex(32)
      break token unless Doorkeeper::AccessToken.exists?(refresh_token: token)
    end
  end

  def render_user(user, client_app, token_type = "Bearer")
    access_token = Doorkeeper::AccessToken.create(resource_owner_id: user.id,
                                                  application_id: client_app.id,
                                                  refresh_token: generate_refresh_token,
                                                  expires_in: Doorkeeper.configuration.access_token_expires_in.to_i,
                                                  scopes: "")
    {
      id: user.id,
      email: user.email,
      role: user.role,
      access_token: access_token.token,
      token_type: token_type,
      expires_in: access_token.expires_in,
      refresh_token: access_token.refresh_token,
      created_at: access_token.created_at.to_time.to_i,
    }
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def home
    @application = Doorkeeper::Application.find_by(name: 'Web Client')

    @application = { 
      name: @application.name,
      client_id: @application.uid,
      client_secret: @application.secret
    }
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
    def is_admin?
      return if current_user&.admin?
  
      respond_to do |format|
        format.json { render json: { error: 'You are not authorized to access this page.' }, status: :unauthorized }
        format.html { redirect_to root_path, notice: 'You are not authorized to access this page.' }
      end
    end
  end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/views/books/_book.html.erb
<div id="<%= dom_id book %>">
  <p>
    <strong>Title:</strong>
    <%= book.title %>
  </p>

  <p>
    <strong>Body:</strong>
    <%= book.body %>
  </p>

</div>

app/views/books/_form.html.erb
<%= form_with(model: book) do |form| %>
  <% if book.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
        <% book.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>

  <div>
    <%= form.label :body, style: "display: block" %>
    <%= form.text_area :body %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Editing book</h1>

<%= render "form", book: @book %>

<br>

<div>
  <%= link_to "Show this book", @book %> |
  <%= link_to "Back to books", books_path %>
</div>

app/views/books/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Books</h1>

<div id="books">
  <% @books.each do |book| %>
    <%= render book %>
    <p>
      <%= link_to "Show this book", book %>
    </p>
  <% end %>
</div>

<%= link_to "New book", new_book_path %>

app/views/books/new.html.erb
<h1>New book</h1>

<%= render "form", book: @book %>

<br>

<div>
  <%= link_to "Back to books", books_path %>
</div>

app/views/books/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @book %>

<div>
  <%= link_to "Edit this book", edit_book_path(@book) %> |
  <%= link_to "Back to books", books_path %>

  <%= button_to "Destroy this book", @book, method: :delete %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Bookable</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
  </head>

  <body>
    <main>
      <div class="container">
        <%= yield %>
      </div>
    </main>
  </body>

  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
</html>

app/views/pages/home.html.erb
<div class="mt-5">
    <h1>Pages#home</h1>
    <p>Find me in app/views/pages/home.html.erb</p>

    <% if user_signed_in? %>
        <%= button_to "Sign out", destroy_user_session_path, method: :delete %>
    <% else %>
        <%= link_to "Sign up", new_user_registration_path %>
        <%= link_to "Sign in", new_user_session_path %>
    <% end %>

    <p>You can test the API with the following credentials</p>
   <div class="container">
        <%= @application.as_json %>
        <ul>
            <li><%= link_to "Web Books", books_path %></li>
            <li><%= link_to "API V1 Books", api_v1_books_path %></li>
            <li><%= link_to "API V1 Android Books", api_v1_android_books_path %></li>
        </ul>
   </div>
</div>